#include "spi.h"
#include "stm32f10x_gpio.h"
#include "stm32f10x_spi.h"
#include "stm32f10x.h"

#if !defined(SPI_HARD)   
void RF_SPI_SCK_H(void)
{
    GPIO_WriteBit(RF_SPI_SCK_Port, RF_SPI_SCK_IO, BOARD_PIN_H);
}
void RF_SPI_SCK_L(void)
{
    GPIO_WriteBit(RF_SPI_SCK_Port, RF_SPI_SCK_IO, BOARD_PIN_L);
}
void RF_SPI_MISO_H(void)
{
    GPIO_WriteBit(RF_SPI_MISO_Port, RF_SPI_MISO_IO, BOARD_PIN_H);
}
void RF_SPI_MISO_L(void)
{
    GPIO_WriteBit(RF_SPI_MISO_Port, RF_SPI_MISO_IO, BOARD_PIN_L);
}
void RF_SPI_MOSI_H(void)
{
    GPIO_WriteBit(RF_SPI_MOSI_Port, RF_SPI_MOSI_IO, BOARD_PIN_H);
}
void RF_SPI_MOSI_L(void)
{
    GPIO_WriteBit(RF_SPI_MOSI_Port, RF_SPI_MOSI_IO, BOARD_PIN_L);
}
void RF_SPI_MISO_SETMODE(GPIOMode_TypeDef mode)
{
    GPIO_InitTypeDef  GPIO_InitStructure;
    GPIO_InitStructure.GPIO_Pin = RF_SPI_MISO_IO;           
    GPIO_InitStructure.GPIO_Mode = mode;     
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;      
    GPIO_Init(RF_SPI_MISO_Port, &GPIO_InitStructure);
}

uint8_t READ_RF_SPI_MISO(void)
{
    return GPIO_ReadInputDataBit(RF_SPI_MISO_Port, RF_SPI_MISO_IO);
}
#endif

void RF_SPI_NSS_H(void)
{
    GPIO_WriteBit(RF_SPI_NSS_Port, RF_SPI_NSS_IO, BOARD_PIN_H);
}
void RF_SPI_NSS_L(void)
{
    GPIO_WriteBit(RF_SPI_NSS_Port, RF_SPI_NSS_IO, BOARD_PIN_L);
}

void spi_init(void)
{
    GPIO_InitTypeDef  GPIO_InitStructure;
    
#if defined(SPI_HARD)    
    //----------SPI1ʱʹ
    RCC_APB2PeriphClockCmd(	RCC_APB2Periph_SPI1, ENABLE );

	GPIO_InitStructure.GPIO_Pin = RF_SPI_SCK_IO | RF_SPI_MISO_IO | RF_SPI_MOSI_IO;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;  //
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(RF_SPI_SCK_Port, &GPIO_InitStructure);

 	GPIO_SetBits(RF_SPI_SCK_Port, RF_SPI_SCK_IO | RF_SPI_MISO_IO | RF_SPI_MOSI_IO);
    /*!< SPI configuration */
    SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex;
    SPI_InitStructure.SPI_Mode = SPI_Mode_Master;
    SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;
    SPI_InitStructure.SPI_CPOL = SPI_CPOL_Low;
    SPI_InitStructure.SPI_CPHA = SPI_CPHA_1Edge;
    SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;
    SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_8;

    SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;
    SPI_InitStructure.SPI_CRCPolynomial = 7;
    SPI_Init(SPI1, &SPI_InitStructure);

    /*!< Enable the SPI1  */
    SPI_Cmd(SPI1, ENABLE);
#else

    GPIO_InitStructure.GPIO_Pin = RF_SPI_MOSI_IO;           
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;      
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;      
    GPIO_Init(RF_SPI_MOSI_Port, &GPIO_InitStructure);
    GPIO_InitStructure.GPIO_Pin = RF_SPI_MISO_IO;           
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;     
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;      
    GPIO_Init(RF_SPI_MISO_Port, &GPIO_InitStructure);
    GPIO_InitStructure.GPIO_Pin = RF_SPI_SCK_IO;            
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;      
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;      
    GPIO_Init(RF_SPI_SCK_Port, &GPIO_InitStructure);
#endif
    GPIO_InitStructure.GPIO_Pin = RF_SPI_NSS_IO;            
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;      
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;      
    GPIO_Init(RF_SPI_NSS_Port, &GPIO_InitStructure);


    RF_SPI_NSS_H();
}
uint8_t SpiReadWrite(uint8_t byteToWrite)
{
    uint8_t i, temp;
    
    temp = 0;   
    __set_PRIMASK(1);   //ȫжϹر
#if defined(SPI_HARD)
	while (SPI_I2S_GetFlagStatus(SPI1, SPI_I2S_FLAG_TXE) == RESET) //ָSPI־λ:ͻձ־λ
    {
        i++;
        if(i > 200)return 0;
    }			  
	SPI_I2S_SendData(SPI1, byteToWrite); //ͨSPIxһ
	i=0;

	while (SPI_I2S_GetFlagStatus(SPI1, SPI_I2S_FLAG_RXNE) == RESET)//ָSPI־λ:ܻǿձ־λ
    {
        i++;
        if(i > 200)return 0;
    }
    /*!< Return the byte read from the SPI bus */
    temp = SPI_I2S_ReceiveData(SPI1);
#else
    RF_SPI_SCK_L();
    for(i=0; i<8; i++)
    {
        if(byteToWrite & 0x80)
        {
          //SpiSetMosiHigh();
          RF_SPI_MOSI_H();
        }
        else
        {
          //SpiSetMosiLow();
          RF_SPI_MOSI_L();
        } 

        byteToWrite <<= 1;

        //SpiSetSckHigh(); 
        RF_SPI_SCK_H();
        temp <<= 1;
        if(READ_RF_SPI_MISO())
        {
          temp ++; 
        }
        //SpiSetSckLow();
        RF_SPI_SCK_L();
    }
#endif
    __set_PRIMASK(0);   //ȫжϴ
    return temp;
}
void SpiWrite(uint8_t byteToWrite)
{
    uint8_t i;  
    __set_PRIMASK(1);   //ȫжϹر
    RF_SPI_MISO_SETMODE(GPIO_Mode_Out_PP);
    RF_SPI_SCK_L();
    for(i=0; i<8; i++)
    {
        if(byteToWrite & 0x80)
        {
          RF_SPI_MISO_H();
        }
        else
        {
          RF_SPI_MISO_L();
        } 
        RF_SPI_SCK_H();
        byteToWrite <<= 1;
        RF_SPI_SCK_L();
    }
    __set_PRIMASK(0);   //ȫжϴ
}
uint8_t SpiRead(void)
{
    uint8_t i, temp;
    
    temp = 0;   
    __set_PRIMASK(1);   //ȫжϹر
    RF_SPI_MISO_SETMODE(GPIO_Mode_IN_FLOATING);
    RF_SPI_SCK_L();
    for(i=0; i<8; i++)
    {
        temp <<= 1;
        RF_SPI_SCK_H();
        if(READ_RF_SPI_MISO())
        {
          temp ++; 
        }
        RF_SPI_SCK_L();
    }
    __set_PRIMASK(0);   //ȫжϴ
    return temp;
}

void SpiWriteData(uint8_t* pData, uint8_t byteCount)
{
  uint8_t i;
  
  for(i=0;i<byteCount;i++)
  {
    SpiReadWrite(*pData);
    pData++;
  }
}

void SpiReadData(uint8_t* pData, uint8_t byteCount)
{
  uint8_t i;
  
  for(i=0;i<byteCount;i++)
  {
    *pData=SpiReadWrite(0xff);
    pData++;
  }
}

